package jp.ossc.installer.tools.inventory;

import java.io.File;
import java.util.Map;

import jp.ossc.installer.util.OpenStandiaXmlFile;

/**
 * Cxg[fBNg[QƂɊւ郁CNXłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public class GetProductInfo {

    /**
     * v_Ng`t@Cv_Ng擾ۂkey<br>
     */
    private static final String PRODUCT_NAME_KEY = "product.name";

    /**
     * v_Ng`t@Cv_Ng̃o[W擾ۂkey<br>
     */
    private static final String PRODUCT_VER_KEY = "product.ver";

    /**
     * 擾` : (v_Ng) (o[W)<br>
     */
    private static final String MODE_NAME_VERSION = "0";

    /**
     * 擾` : (v_Ng)<br>
     */
    private static final String MODE_NAME = "1";

    /**
     * 擾` : (o[W)<br>
     */
    private static final String MODE_VERSION = "2";

    /**
     * tH[}bg : (v_Ng) (o[W)<br>
     */
    private static final String FORMAT_NAME_VERSION = "%s %s";

    /**
     * tH[}bg : (v_Ng)<br>
     */
    private static final String FORMAT_NAME = "%s";

    /**
     * tH[}bg : (o[W)<br>
     */
    private static final String FORMAT_VERSION = "%s";

    /**
     * s<br>
     * @param stackXmlPath X^bN`t@C(tpX)
     * @param productNo v_NgNo
     * @param mode 擾` 0 : (v_Ng) (o[W) / 1 : (v_Ng) / 2 : (o[W)
     * @return v_Ngyуv_Ng () [name] [1.0.0]
     * @throws Throwable Throwable
     */
    public String execute(final String stackXmlPath, final String productNo,
            final String mode) {
        // w肳ꂽv_NgNõv_Ng`t@Cǂݍ
        final File stackXml = new File(stackXmlPath);
        final File productXml = OpenStandiaXmlFile.getProductFilePath(
            stackXml, productNo);
        final Map<String, String> productXmlMap = OpenStandiaXmlFile
                .getProductXmlProperties(stackXml, productXml);

        // w肳ꂽv_Ng̃v_Ngƃo[W擾
        final String name = productXmlMap.get(PRODUCT_NAME_KEY);
        final String version = productXmlMap.get(PRODUCT_VER_KEY);

        // Ԃl̐ݒ
        String info = null;
        if (mode == null) {
            // Ȃ
        } else if (mode.equals(MODE_NAME_VERSION)) {
            info = String.format(FORMAT_NAME_VERSION, name, version);
        } else if (mode.equals(MODE_NAME)) {
            info = String.format(FORMAT_NAME, name);
        } else if (mode.equals(MODE_VERSION)) {
            info = String.format(FORMAT_VERSION, version);
        } else {
            // Ȃ
        }
        return info;
    }

}
