package jp.ossc.installer.util;

import java.io.File;
import java.util.Map;

import jp.ossc.tools.ant.taskdefs.ExtendsXmlProperty;

import org.apache.tools.ant.Project;

/**
 * OpenStandia/InstallerŎgpXMLt@C<br>
 * [eBeB[NXłB<br>
 * @author S.Fujii
 * @version 1.0
 * @since 1.0
 */
public class OpenStandiaXmlFile {

    /**
     * X^bN`t@CWindowspOpenStandiaz[fBNg擾ۂkey<br>
     */
    private static final String DEFINE_WINDOWS_OPENSTANDIA_INSTALLDIR_KEY = "define.windows.openStandia.installDir";

    /**
     * X^bN`t@CLinuxpOpenStandiaz[fBNg擾ۂkey<br>
     */
    private static final String DEFINE_LINUX_OPENSTANDIA_INSTALLDIR_KEY = "define.linux.openStandia.installDir";

    /**
     * X^bN`t@C`Ăv_Ng擾ۂkey<br>
     */
    private static final String STACK_PRODUCTS_PRODUCT_NUM_KEY = "stack.products.product.num";

    /**
     * X^bN`t@C`Ăv_Ng擾ۂkey<br>
     */
    private static final String STACK_PRODUCTS_PRODUCT_NO_KEY = "stack.products.product.%d.no";

    /**
     * X^bN`t@C肠v_Ng`擾ۂkey<br>
     */
    private static final String STACK_PRODUCTS_PRODUCT_DEF_KEY = "stack.products.product.%d.def";

    /**
     * Cxg[i[XMLt@C<br>
     */
    private static final String INVENTORY_XML_FILE_NAME = "openstandia-inventory.xml";

    /**
     * Cxg[i[fBNg<br>
     */
    private static final String INVENTORY_XML_DIR_NAME = "Inventory";

    /**
     * xbZ[W : X^bN`t@Cƃv_Ngԍv_Ng`t@C̃pX擾łȂꍇ<br>
     */
    private static final String WARN_FAILED_GET_PRODUCT_XML_PATH = "X^bN`t@C[%s]v_Ngԍ[%s]̃v_Ng`t@Cւ̃pX擾ł܂B";

    /**
      * RXgN^[<br>
      */
    private OpenStandiaXmlFile () {
        super();
    }

    /**
     * AntgpăX^bNݒt@Cǂݍ<br>
     *  QƉ̂<br>
     * @param stackXml X^bNݒt@C
     * @return {ϐɐݒ肳KeyAValuȇgݍ킹i[Map
     */
    public static Map<String, String> getStackXmlProperties(
            final File stackXml) {
        final String stackXmlDir = stackXml.getParent();
        final File commonXml = new File(stackXmlDir + "/common.xml");
        final String moreTypes = "install-before, product, install-after, depend";
        return getXmlProperties(stackXml, commonXml, moreTypes);
    }

    /**
     * Antgpăv_Ngݒt@Cǂݍ<br>
     *  QƉ̂<br>
     * @param stackXml X^bNݒt@C
     * @param productXml v_Ngݒt@C
     * @return {ϐɐݒ肳KeyAValuȇgݍ킹i[Map
     */
    public static Map<String, String> getProductXmlProperties(
            final File stackXml, final File productXml) {
        final String stackXmlDir = stackXml.getParent();
        final File commonXml = new File(stackXmlDir + "/common.xml");
        final String moreTypes = "pattern, file, exec, arg";
        return getXmlProperties(productXml, commonXml, moreTypes);
    }

    /**
     * OpenStandiaz[fBNg擾<br>
     * @param stackXmlMap X^bN`t@C
     * @return OpenStandiaz[fBNg
     */
    public static String getOpenStandiaHome(
            final Map<String, String> stackXmlMap) {
        final String osName = SystemUtil.getOsName();
        String defineName = null;
        if (osName.contains("windows")) {
            defineName = DEFINE_WINDOWS_OPENSTANDIA_INSTALLDIR_KEY;
        } else {
            defineName = DEFINE_LINUX_OPENSTANDIA_INSTALLDIR_KEY;
        }
        return stackXmlMap.get(defineName);
    }

    /**
     * CxgfBNgւ̃pX擾<br>
     * @param openStandiaHomeDir OpenStandiaz[fBNg
     * @return CxgfBNgւ̃pX
     */
    public static String getInventoryDirPath(final String openStandiaHomeDir) {
        return openStandiaHomeDir + "/" + INVENTORY_XML_DIR_NAME;
    }

    /**
     * Cxgt@Cւ̃pX擾<br>
     * @param openStandiaHomeDir OpenStandiaz[fBNg
     * @return Cxgt@Cւ̃pX
     */
    public static String getInventoryFilePath(final String openStandiaHomeDir) {
        return getInventoryDirPath(openStandiaHomeDir) + "/"
               + INVENTORY_XML_FILE_NAME;
    }

    /**
     * Cxgt@C݂邩ǂ<br>
     * @param openStandiaHomeDir OpenStandiaz[fBNg
     * @return true : ݂ / false : ݂Ȃ
     */
    public static boolean existsInventoryFile(
            final Map<String, String> stackXmlMap) {
        final String openStandiaHomeDir = getOpenStandiaHome(stackXmlMap);
        final String inventoryFilePath = getInventoryFilePath(openStandiaHomeDir);
        // Cxg[t@C݂邩ǂ
        final File inventory = (new File(inventoryFilePath))
                .getAbsoluteFile();
        if (inventory.exists() && inventory.isFile()) {
            // ݂ꍇ
            return true;
        } else {
            // ݂Ȃꍇ
            return false;
        }
    }

    /**
     * X^bN`t@Cyуv_NgNov_Ng`t@CpX擾<br>
     * @param stackXml X^bN`t@C
     * @param no v_NgNo
     * @return v_Ng`t@CpX
     */
    public static File getProductFilePath(final File stackXml, final String no) {
        // X^bN`t@Cǂݍ
        final Map<String, String> stackXmlMap = OpenStandiaXmlFile
                .getStackXmlProperties(stackXml);

        // IɊǗĂ郊Xgԍ擾
        final int listNo = getListNo(stackXmlMap, no);

        // X^bN`t@C葊΃pX擾
        final String stackProductsProductDefkey = String.format(
            STACK_PRODUCTS_PRODUCT_DEF_KEY, listNo);
        final String productPath = stackXmlMap
                .get(stackProductsProductDefkey);

        // ΃pX擾łǂ
        if (productPath == null) {
            final String msg = String.format(
                WARN_FAILED_GET_PRODUCT_XML_PATH, stackXml.getAbsolutePath(),
                no);
            System.out.println(msg);
            return null;
        } else {
            // X^bN`t@CƂFileIuWFNg𐶐
            final String stackXmlDir = stackXml.getParent();
            final File productFile = new File(stackXmlDir + "/" + productPath);
            return productFile;
        }
    }

    /**
     * X^bN`t@Cɂv_Ng`<br>
     * IɊǗĂ郊Xgԍ擾܂B<br>
     *  v_NgNoł͂܂B<br>
     * @param stackXmlMap X^bN`i[Map
     * @param no v_NgNo
     * @return IɊǗĂ郊Xgԍ
     */
    public static int getListNo(final Map<String, String> stackXmlMap,
            final String no) {
        final String numStr = stackXmlMap.get(STACK_PRODUCTS_PRODUCT_NUM_KEY);
        final int num = Integer.parseInt(numStr);
        int listNo = -1;
        for (int i = 0; i < num; i++) {
            final String stackProductsProductNoKey = String.format(
                STACK_PRODUCTS_PRODUCT_NO_KEY, i + 1);
            final String listNoStr = stackXmlMap
                    .get(stackProductsProductNoKey);
            if (listNoStr == null) {
                // Ȃ
            } else if (listNoStr.equals(no)) {
                listNo = i + 1;
                break;
            } else {
                // Ȃ
            }
        }
        return listNo;
    }

    /**
     * AntgpXMLǂݍ<br>
     *  QƉ̂<br>
     * @param targetXml ǂݍXMLt@C
     * @param commonXml ʐݒXMLt@C
     * @param moreTypes `ƂēǂݍރvpeB(J}؂)
     * @return {ϐɐݒ肳KeyAValuȇgݍ킹i[Map
     */
    @SuppressWarnings("unchecked")
    protected static Map<String, String> getXmlProperties(
            final File targetXml, final File commonXml, final String moreTypes) {
        Project project = new Project();
        project.setName("OpenStandia");
        project.setBasedir("..");

        // ʐݒǂݍ
        ExtendsXmlProperty commonXmlProperty = new ExtendsXmlProperty();
        commonXmlProperty.setProject(project);
        commonXmlProperty.setFile(commonXml);
        commonXmlProperty.setSemanticAttributes(true);
        commonXmlProperty.setKeeproot(true);
        commonXmlProperty.setMoreTypes(moreTypes);
        commonXmlProperty.execute();

        // w肳ꂽXMLt@Cǂݍ
        ExtendsXmlProperty xmlProperty = new ExtendsXmlProperty();
        xmlProperty.setProject(project);
        xmlProperty.setFile(targetXml);
        xmlProperty.setSemanticAttributes(true);
        xmlProperty.setKeeproot(true);
        xmlProperty.setMoreTypes(moreTypes);
        xmlProperty.execute();
        final Map<String, String> properties = project.getProperties();

        return properties;
    }

}
